## ros-melodic-hironx-ros-bridge 2.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(hironx_ros_bridge)

find_package(catkin REQUIRED COMPONENTS hrpsys_ros_bridge roslib roslint rostest)
find_package(Boost REQUIRED COMPONENTS system)

catkin_package(
    CATKIN_DEPENDS hrpsys_ros_bridge roslib #
    INCLUDE_DIRS include
)

catkin_python_setup()

add_custom_command(OUTPUT ${PROJECT_SOURCE_DIR}/models/kawada-hironx.dae
  COMMAND ${catkin_EXTRAS_DIR}/test/download_checkmd5.py
  https://github.com/rdiankov/collada_robots/raw/master/kawada-hironx.zae
  ${PROJECT_SOURCE_DIR}/models/kawada-hironx.zae
  be4b0015914d33a5aaa24ee055bcdbc8
  COMMAND unzip -u ${PROJECT_SOURCE_DIR}/models/kawada-hironx.zae
  WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/models
  VERBATIM)
# commit generated files due to  https://code.google.com/p/rtm-ros-robotics/issues/detail?id=187
#compile_collada_model(${PROJECT_SOURCE_DIR}/models/kawada-hironx.dae)

# set ROBOT_NAME and OPENHRP3 for configure_file
set(PKG_CONFIG_PATH "${openhrp3_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}") # for openrtm3.1.pc
execute_process(
  COMMAND pkg-config --variable=idl_dir openhrp3.1
  OUTPUT_VARIABLE OPENHRP_IDL_DIR
  RESULT_VARIABLE RESULT
  OUTPUT_STRIP_TRAILING_WHITESPACE)
if(NOT RESULT EQUAL 0)
  set(OPENHRP_FOUND FALSE)
endif()
# OPENHRP_IDL_DIR = <openhrp3>/share/OpenHRP-3.1/idl/
set(OPENHRP_SAMPLE_DIR ${OPENHRP_IDL_DIR}/../../../)
set(OPENHRP3 ${OPENHRP_SAMPLE_DIR})  # for longfloor.wrl
set(ROBOT_NAME kawada-hironx)

message("Configure ${ROBOT_NAME} related file with OPENHRP3=${OPENHRP3}")
configure_file(conf/RobotHardware.conf.in       ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}.RobotHardware.conf)
configure_file(conf/nosim.RobotHardware.conf.in ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_nosim.RobotHardware.conf)
configure_file(conf/xml.in                      ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}.xml)
configure_file(conf/nosim.xml.in                ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_nosim.xml)
configure_file(conf/conf.in                     ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}.conf)
configure_file(conf/nosim.conf.in               ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_nosim.conf)
configure_file(conf/rtc_on_off_test.conf.in     ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_rtc_on_off_test.conf)
add_custom_target(${PROJECT_NAME}_model_files ALL DEPENDS ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}.RobotHardware.conf ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_nosim.RobotHardware.conf ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}.xml ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_nosim.xml ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}.conf ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_nosim.conf ${PROJECT_SOURCE_DIR}/conf/${ROBOT_NAME}_rtc_on_off_test.conf)

include_directories(include ${catkin_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS})

#add_definitions("-std=c++0x")
add_library(
  ros_client_cpp include/ros_client.cpp
)

add_executable(
    acceptancetest_hironx_cpp src/acceptancetest_hironx.cpp
)

target_link_libraries(
  acceptancetest_hironx_cpp
  ros_client_cpp ${catkin_LIBRARIES} ${Boost_LIBRARIES}
)

install(TARGETS acceptancetest_hironx_cpp
        RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(DIRECTORY include DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})
install(DIRECTORY launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} PATTERN ".svn" EXCLUDE)
install(DIRECTORY scripts DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} USE_SOURCE_PERMISSIONS PATTERN ".svn" EXCLUDE)
install(DIRECTORY conf DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} PATTERN ".svn" EXCLUDE)
install(DIRECTORY models DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} PATTERN ".svn" EXCLUDE)
install(DIRECTORY resource DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})
install(DIRECTORY test DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION} USE_SOURCE_PERMISSIONS PATTERN ".svn" EXCLUDE)
install(FILES rqt_plugin.xml DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

install(CODE "
  message(\"++ glob files under \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/conf/\")
  file(GLOB _xml_files \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/conf/*.xml)
  file(GLOB _conf_files \$ENV{DESTDIR}/${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/conf/*.conf)
  message(\"++ sed -i s@${PROJECT_SOURCE_DIR}@${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}@ \${_file}\")
  if (EXISTS ${openhrp3_SOURCE_DIR})
    message(\"++sed -i s@${openhrp3_SOURCE_DIR}/share/OpenHRP-3.1@${CMAKE_INSTALL_PREFIX}/share/openhrp3/share/OpenHRP-3.1@g \${_conf_file}\")
  endif()
  message(\"++ xml_files:\${_xml_files} \")
  message(\"++ conf_files:\${_conf_files} \")
  foreach(_file \${_xml_files} \; \${_conf_files} )
    message(\"  ++ fix \${_file} \")
    execute_process(COMMAND sed -i s@${PROJECT_SOURCE_DIR}@${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}@ \${_file} )
    if (EXISTS ${openhrp3_SOURCE_DIR})
      execute_process(COMMAND sed -i s@${openhrp3_SOURCE_DIR}/share/OpenHRP-3.1@${CMAKE_INSTALL_PREFIX}/share/openhrp3/share/OpenHRP-3.1@g \${_file} )
    endif()
    execute_process(COMMAND sed -i s@${PROJECT_SOURCE_DIR}@${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}@ \${_file} )
  endforeach()
  ")

install(TARGETS acceptancetest_hironx_cpp ros_client_cpp
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

add_rostest(test/test-hironx.test)
add_rostest(test/test-hironx-ros-bridge.test)
add_rostest(test/test-hironx-ros-bridge-send.test)
add_rostest(test/test-hironx-ros-bridge-pose.test)
add_rostest(test/test-hironx-ros-bridge-controller.test)
add_rostest(test/test-hironx-rtc-on-off.test)

if (CATKIN_ENABLE_TESTING)
  catkin_add_nosetests(test/test_no_ros.py)
endif()

roslint_python(scripts/hironx.py src/hironx_ros_bridge/hironx_client.py src/hironx_ros_bridge/ros_client.py src/hironx_ros_bridge/constant.py src/hironx_ros_bridge/testutil/test_rosbridge.py)
roslint_cpp()

=== robot/hrpiob/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
set(CMAKE_INSTALL_PREFIX /opt/nextage-open CACHE STRING "install prefix")

#
# BUILD_TYPE
#
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
    FORCE)
endif()

#if (NOT ROBOT)
#  message(FATAL_ERROR "please define ROBOT")
#endif()

#set(ROBOT CACHE STRING "robot type")


#
# CXX
#
if(QNXNTO)
SET (CMAKE_CXX_COMPILER   QCC )
SET (CMAKE_CXX_FLAGS      "-V4.4.2,gcc_ntox86_cpp -Wall")
endif()

#
# set path
#
#include_directories(/opt/nextage-open/include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
link_directories(${CMAKE_CURRENT_BINARY_DIR})
#link_directories(/opt/nextage-open/lib)

#if(QNXNTO)
include_directories(/opt/jsk/include /usr/pkg/include)
link_directories(/opt/jsk/lib /usr/pkg/lib)
#endif()

# hrpsys-base
#include(FindPkgConfig)

execute_process(
  COMMAND pkg-config --cflags-only-I hrpsys-base
  OUTPUT_VARIABLE HRPSYSBASE_CXX_FLAGS
  RESULT_VARIABLE RESULT)

message("HRPSYSBASE_CXX_FLAGS: ${HRPSYSBASE_CXX_FLAGS}")

add_definitions(${HRPSYSBASE_CXX_FLAGS})


#
# set target
#
##add_library(NextageOpenIo      SHARED iob.cpp)
add_library(hrpIo      SHARED iob.cpp)

#set_target_properties(hrpIo PROPERTIES PUBLIC_HEADER nextage-open.hpp)

#
# set libraries
#
if(NOT QNXNTO)
#target_link_libraries(NextageOpenIo rt boost_thread)
target_link_libraries(hrpIo rt boost_thread)
else()
#target_link_libraries(NextageOpenIo boost_thread)
target_link_libraries(hrpIo boost_thread)
endif()

#
# install
#
#install(TARGETS iob unlock_iob
#install(TARGETS NextageOpenIo
install(TARGETS hrpIo
	RUNTIME DESTINATION bin CONFIGURATIONS Release Debug
	LIBRARY DESTINATION lib CONFIGURATIONS Release Debug
	PUBLIC_HEADER DESTINATION include CONFIGURATIONS Release Debug
)

=== debian/changelog ===
ros-melodic-hironx-ros-bridge (2.2.0-1stretch) stretch; urgency=high

  * force set ORBgiopMaxMsgSize=2147483648  for hironx_client.py (#540 <https://github.com/start-jsk/rtmros_hironx/issues/540>)
    
      * increase test_no_moveit
      * hot fix for https://github.com/start-jsk/rtmros_hironx/issues/539
        On 16.04 (omniorb4-dev 4.1) if we start openhrp-model-loader with   <env name="ORBgiopMaxMsgSize" value="2147483648" /> all connection(?) conect respenct giopMaxMsgSize
        But on 18.04 (omniorb4-dev 4.2) wnneed to set ORBgiopMaxMsgSize=2147483648  for each clients
    
  * [hironx_ros_bridge] Enable to run CollisionDetector RTC by setting conf (Robot.conf) (#535 <https://github.com/start-jsk/rtmros_hironx/issues/535>)
    
      * [hironx_ros_bridge] Simplify CollisionDetector disabling specific to HIRONX
      * [hironx_ros_bridge] Generalize disabling/enabling RTCs from conf
      * [hironx_ros_bridge] Enable to run CollisionDetector RTC by setting conf (Robot.conf)
      * [hironx_ros_bridge] Add test to check if CollisionDetector is disabled with default conf
      * [hironx_ros_bridge] Add test to disable/enable RTCs from conf
    
  * Contributors: Kei Okada, Shun Hasegawa

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 12 May 2020 15:00:00 -0000

ros-melodic-hironx-ros-bridge (2.1.1-1stretch) stretch; urgency=high

  * Avoid node clashing when USE_COLLISIONCHECK is true (#528 <https://github.com/start-jsk/rtmros_hironx/issues/528> )
  * hironx_ros_bridge/test/test-hironx-ros-bridge.test: increse time-limit from 100 to 200 (#531 <https://github.com/start-jsk/rtmros_hironx/issues/531> )
    
      * increse time-limit from 100 to 200, to solve https://api.travis-ci.org/v3/job/407698809/log.txt
    
  * fix python_qt_binding for qt5 (#525 <https://github.com/start-jsk/rtmros_hironx/issues/525> )
  * hironx_ros_bridge/src/hironx_ros_bridge/old_api.py: add python file to support old api (#521 <https://github.com/start-jsk/rtmros_hironx/issues/521> )
  * Contributors: Guilherme Affonso, Kei Okada, Felix von Drigalski

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Tue, 19 Feb 2019 15:00:00 -0000

ros-melodic-hironx-ros-bridge (2.1.0-1stretch) stretch; urgency=high

  * get nshost from rtmnameserver, sometimes nshost is different from rosmaster (#513 <https://github.com/start-jsk/rtmros_hironx/issues/513>)
  * hironx_ros_bridge_real.launch: support HRPSYS_PY_{PKG,NAME,ARGS} as https://github.com/start-jsk/rtmros_common/blob/master/hrpsys_tools/launch/hrpsys.launch#L97-L103 (#514 <https://github.com/start-jsk/rtmros_hironx/issues/514>)
  * Add hand_joint_state_publisher.py for 2017/Feb? verison of MoveIt, that strictly requrired all robot states for planning (#519 <https://github.com/start-jsk/rtmros_hironx/issues/519>)
  * Contributors: Kei Okada, Ryosuke Tajima

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Wed, 06 Sep 2017 15:00:00 -0000

ros-melodic-hironx-ros-bridge (2.0.0-1stretch) stretch; urgency=high

  * [ros_bridge.py][startImpedance_315_3] More precise error message. (#502 <https://github.com/start-jsk/rtmros_hironx/issues/502>)
    *  When run by itself, getImpedanceControllerParam command at least finishes, so it's not failing. The error message is a bit misleading about what happened internally in startImpedance_315_3 method.
  * use docker to run tests and add kinetic test (#517 <https://github.com/start-jsk/rtmros_hironx/issues/517> from k-okada/kinetic)
    * fix install(CDOE
    * use control_msgs is pr2_controllers_msgs is not exists
    * test/test-hironx.test: add retry=4
    * remove pr2_controller_msgs and use control_msgs
  * enable to output forcesensor value on simulation (#510 <https://github.com/start-jsk/rtmros_hironx/issues/510>)
  * [qnx dynpick] Add a working setting to start sensor drivers connected via USB hub (#509 <https://github.com/start-jsk/rtmros_hironx/issues/509>)
  * robot_description before staring ROS_Client (RobotCommander) (#511 <https://github.com/start-jsk/rtmros_hironx/issues/511>)
  * clearOfGroup after setTargetPose breaks sequencer (#505 <https://github.com/start-jsk/rtmros_hironx/issues/505>)
    * [ros_bridge] Set hrpsys version limitation to some methods.
    * temporaly workaround utnil https://github.com/fkanehiro/hrpsys-base/pull/1141, send setJointAnglesOfGrup to clear sequencer
    * add test to check https://github.com/tork-a/rtmros_nextage/issues/332 situation
  * Contributors: Isaac I.Y. Saito, Kei Okada

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Wed, 09 Aug 2017 15:00:00 -0000

ros-melodic-hironx-ros-bridge (1.1.25-1stretch) stretch; urgency=high

  * [QNX log fetch] Fix to get it working again.
  * [QNX log fetch] Add a feature to remove existing .log files on QNX to save disk space. #508 <https://github.com/start-jsk/rtmros_hironx/pull/508>
  * Contributors: Isaac I.Y. Saito

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Thu, 01 Jun 2017 15:00:00 -0000

ros-melodic-hironx-ros-bridge (1.1.24-1stretch) stretch; urgency=high

  * [py] Better error msg, better doc about impedance control. #496 <https://github.com/start-jsk/rtmros_hironx/pull/496>, #499 <https://github.com/start-jsk/rtmros_hironx/pull/499>
  * Contributors: Isaac I.Y. Saito

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Mon, 08 May 2017 15:00:00 -0000

ros-melodic-hironx-ros-bridge (1.1.23-1stretch) stretch; urgency=high

  * [enhancement][test] Common testcase module location change #490 <https://github.com/start-jsk/rtmros_hironx/issues/490>.
  * [doc] More elaboration on startImpedance* methods.
  * Contributors: Isaac I.Y. Saito

 -- Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>  Sun, 02 Apr 2017 15:00:00 -0000

ros-melodic-hironx-ros-bridge (1.1.22-1stretch) stretch; urgency=high

  * [Improve][rtm py] Return more specific error when actual error occurs. #487 <https://github.com/start-jsk/rtmros_hironx/issues/487>.
  * [test] Export a common test py module. #490 <https://github.com/start-jsk/rtmros_hironx/issues/490>.


=== debian/control ===
Source: ros-melodic-hironx-ros-bridge
Section: misc
Priority: optional
Maintainer: Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), gnuplot, ros-melodic-catkin, ros-melodic-control-msgs, ros-melodic-hrpsys-ros-bridge, ros-melodic-mk, ros-melodic-rosbash, ros-melodic-rosbuild, ros-melodic-roslang, ros-melodic-roslib, ros-melodic-roslint, unzip
Homepage: http://ros.org/wiki/hironx_ros_bridge
Standards-Version: 3.9.2

Package: ros-melodic-hironx-ros-bridge
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gnuplot, ros-melodic-control-msgs, ros-melodic-hrpsys-ros-bridge, ros-melodic-moveit-commander, ros-melodic-openni2-launch, ros-melodic-rosbash, ros-melodic-roslang, ros-melodic-roslib, ros-melodic-rospy, ros-melodic-tf
Description: ROS-OpenRTM interfacing package for the opensource version of Kawada's Hiro/NEXTAGE dual-arm robot.
 NOTE: This package is multi-license -- pay attention to file header in each file where license is declared. For Creative Commons nc 4.0 applied, see here. This package also contains some sensor driver software (as of April 2016 they are the following force sensors such as Dynpick and JR3) for QNX. These drivers are stored in this robot-specific package for not many reasons than they are slightly customized for the robot. So if you can separate those as a standalone, generic package that'll be appreciated (please just let us know if you will).
